rawset(_G, "strash_debug", CV_RegisterVar({
	name = "strash_debug",
	defaultvalue = "off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
}))

local function strash_Log(p, q, pfx) -- debug
	pfx= pfx or "strashBot"
	q= q or "nil"
	if type(p)=="string" then
		p= server
		q= p.." | "..q
	end
	if not strash_debug then
		strash_debug= CV_FindVar("strash_debug")
	end
	if (not strash_debug) or (not strash_debug.value) then
		return
	end
	if not p then
		print("["..pfx.."](invalid playername) - "..q)
		return
	end
	if not p.name then
		print("["..pfx.."](non-player) - "..q)
		return
	end
	print("["..pfx.."]("..p.name..") - "..q)
end
rawset(_G, "strash_Log", strash_Log)



--               --
-- for bugfixing --
--               --

-- registering this fixes a bug with
-- ( hostmod 16 + HugeQuest 12 )
local hostmod_restat = CV_RegisterVar({
	name = "hm_intermission",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})
--
--               --
