-- yeah okay, so, just as I was about to release that shit 1.4/5 dropped!!
-- with the introduction of 'kartgametypepreference', I don't even know what to do with this
-- oh well, should still work kinda, let's see


local function strash_log(p, q) -- debug
	strash_Log(p,q,"strashBot_gametype")
end

local TICRATE= TICRATE

local _gametyping= {}
rawset(_G,"strash_gametype", _gametyping)

local GAMETYPE_SETTINGS={
    RACE_ONLY= 0,
    BATTLE_ONLY= 1,
    SWITCHING= 2
}
_gametyping.GAMETYPE_SETTINGS= GAMETYPE_SETTINGS

local cvar_voteRuleChanges= nil
local cvar_inttime= nil
-- ok, so about value, -1 is None, 0 Race, and 1 Battle
local cvar_gametypePref= nil

local function evaluateCurrentGameTypeSetting()
    if not cvar_voteRuleChanges then
        cvar_voteRuleChanges= CV_FindVar("kartvoterulechanges")
    end
    if not cvar_gametypePref then
        cvar_gametypePref= CV_FindVar("kartgametypepreference")
    end

    if (cvar_voteRuleChanges and (cvar_voteRuleChanges.value~=0))
        -- and now I have to struggle with this on top of it
        or (cvar_gametypePref and
            (cvar_gametypePref.value>=0 and cvar_gametypePref.value~=gametype)
            )
    then
        return GAMETYPE_SETTINGS.SWITCHING
    else
        return ((gametype==1)
                and GAMETYPE_SETTINGS.BATTLE_ONLY
                or GAMETYPE_SETTINGS.RACE_ONLY
        )
    end
end
_gametyping.evaluateCurrentGameTypeSetting= evaluateCurrentGameTypeSetting


local TRANSITION= {
    NOTHING= 0,
    PREPARE= 1,
    NOW= 2,

    DONE= 3
}

local transitionHandler= {
    target_gametype= nil,
    
    state= TRANSITION.NOTHING,

    inttime_save= 12,
    intermission_tic= 0
}

local function th_next()
    transitionHandler.state= ($+1)%(TRANSITION.DONE+1)
    strash_log(consoleplayer, "transitHandlr - state is now "..transitionHandler.state)
end

local function prepareGameTypeSettingChange(gametypesetting)
    if(transitionHandler.state~=TRANSITION.NOTHING and transitionHandler.state~=TRANSITION.DONE) then
        print("Can't start transition to another gametype, as another transition is"..
                "already happening..."
        )
        strash_log(server, "transitionhandler is "..transitionHandler.state)

        return
    end
    
    local gt_str= (
        gametypesetting==GAMETYPE_SETTINGS.SWITCHING
            and "race + battle"
            or  (gametypesetting==GAMETYPE_SETTINGS.RACE_ONLY
                    and "race only"
                    or "battle only (wtf?!)"
                )

    )
    print("Switching to "..gt_str.." settings next round")
    gametypesetting= ( ($==nil or $>GAMETYPE_SETTINGS.SWITCHING)
            and GAMETYPE_SETTINGS.RACE_ONLY 
            or  $
    )

    transitionHandler.target_gametype= gametypesetting
    transitionHandler.state= TRANSITION.PREPARE

    if transitionHandler.target_gametype~=GAMETYPE_SETTINGS.SWITCHING then
        COM_BufInsertText(server, "kartgametypepreference "..transitionHandler.target_gametype)
        strash_log(server, "[prepareGTTransition] kartgtpref is now "..transitionHandler.target_gametype)
    else
        COM_BufInsertText(server, "kartgametypepreference 0")
        strash_log(server, "[prepareGTTransition] kartgtpref is now 0 (Race)")
    end
end

local function onTransitionDone()
    if transitionHandler.state==TRANSITION.DONE then
        strash_log(consoleplayer, "[onTransitionDone] state is indeed TRANSITION.DONE")
        COM_BufInsertText(server, "inttime "..transitionHandler.inttime_save)
        th_next()
    end
end


addHook("ThinkFrame", function()
    if leveltime<4 then
        local cur_gamet_set= evaluateCurrentGameTypeSetting()

        if (leveltime==2) then
            if cur_gamet_set==GAMETYPE_SETTINGS.SWITCHING then
                if gametype==0 and cvar_voteRuleChanges.value~=1 then
                    -- Race? Sometimes change, yeah sometimes is good. idk...
                    -- planned for 1.3 -_-'
                    -- strash_log(consoleplayer, "[frame-think](lvlt2) changing votes rules to 1!")
                    -- COM_BufInsertText(server, "kartvoterulechanges 1")
                    -- okay, now this should be good with latest release I guess
                    strash_log(consoleplayer, "[frame-think](lvlt2) changing votes rules to 2!")
                    COM_BufInsertText(server, "kartvoterulechanges 2")
                elseif gametype==1 and cvar_voteRuleChanges.value~=3 then
                    -- Battle? Yuk! Always have an escape route for next vote round
                    strash_log(consoleplayer, "[frame-think](lvlt2)  changing votes rules to 3!")
                    COM_BufInsertText(server, "kartvoterulechanges 3")
                end
            -- more kartgametypepreference shit to handle, thx 1.5...
                if cvar_gametypePref.value~=0 then
                    strash_log(consoleplayer, "[frame-think](lvlt2) gametypeprefs rules to 0 (race)!")
                    COM_BufInsertText(server, "kartgametypepreference 0")
                end
            elseif cvar_gametypePref.value~=cur_gamet_set then
                --'battle or race only' need to have kartgametypepreference set accordingly
                strash_log(consoleplayer, "[frame-think](lvlt2) gametypeprefs rules to "..cur_gamet_set)
                COM_BufInsertText(server, "kartgametypepreference "..cur_gamet_set)
            end

            if transitionHandler.state==TRANSITION.NOW and
                cur_gamet_set~=GAMETYPE_SETTINGS.SWITCHING
            then
                strash_log(consoleplayer, "leaving this level to finish exclusive "..
                    ((gametype==0) and "RACE" or "BATTLE")..
                    " transition"
                )

                if not cvar_inttime then
                    cvar_inttime= CV_FindVar("inttime")
                end
                transitionHandler.inttime_save= cvar_inttime.value
                COM_BufInsertText(server, "kartvoterulechanges 0; inttime 0")
            end
        elseif leveltime==3 and transitionHandler.state==TRANSITION.NOW then
            -- yeah, I think 'inttime' change needs to wait next tic to be applied to current game
            strash_log(consoleplayer,"[frame-think](lvlt2) trnasition should be done now...")
            th_next()
            
            if cur_gamet_set~=GAMETYPE_SETTINGS.SWITCHING then
                G_ExitLevel()
            end
        end

    end
end)

addHook("IntermissionThinker", function()
    onTransitionDone()

    if transitionHandler.state==TRANSITION.PREPARE then
        strash_log(consoleplayer, "[intermission-think] preparing transition "
            ..transitionHandler.intermission_tic
        )
        if not cvar_inttime then cvar_inttime= CV_FindVar("inttime") end

        if cvar_inttime and
            (transitionHandler.intermission_tic==(cvar_inttime.value*TICRATE - 2))
        then
            th_next()
            if (transitionHandler.target_gametype~=GAMETYPE_SETTINGS.SWITCHING) then
                strash_log(consoleplayer, "[intermission-think] preparing strong switch!")
                COM_BufInsertText(server, "kartvoterulechanges 0; "..
                    ( "map map01 -gametype " ..
                        ( (transitionHandler.target_gametype==GAMETYPE_SETTINGS.BATTLE_ONLY)
                            and "1" or "0"
                        )
                        .. " -force" )
                )
            else
                strash_log(consoleplayer, "[intermission-think] changing votes rules to 3!")
                COM_BufInsertText(server, "kartvoterulechanges 3")
            end
        end
    end
    
    transitionHandler.intermission_tic= $+1
end)

addHook("VoteThinker", function()
    onTransitionDone()
    transitionHandler.intermission_tic= 0
end)

addHook("NetVars", function(net)
    transitionHandler= net($)
end)

local function onServerEmpty_prepareReset()
	strash_log(server, "onServerEmpty_prepareReset")

    transitionHandler.intermission_tic= 0
    transitionHandler.target_gametype= nil
    transitionHandler.state= TRANSITION.NOTHING
    transitionHandler.inttime_save= (($<=0) and 12 or $)

    COM_BufInsertText(server, "inttime "..transitionHandler.inttime_save)
	COM_BufInsertText(server, "gametype 0; kartvoterulechanges 0")
end
strash_gametype.onServerEmpty_prepareReset= onServerEmpty_prepareReset




COM_AddCommand("race_n_battle", function(p)
        prepareGameTypeSettingChange(GAMETYPE_SETTINGS.SWITCHING)        
    end,
    1
)

COM_AddCommand("race_only", function(p)
        prepareGameTypeSettingChange(GAMETYPE_SETTINGS.RACE_ONLY)        
    end,
    1
)

COM_AddCommand("battle_only", function(p)
        prepareGameTypeSettingChange(GAMETYPE_SETTINGS.BATTLE_ONLY)        
    end,
    1
)
