local strash_debug= nil

local function strash_log(p, q) -- debug
	strash_Log(p,q,"strashBot_infoMsg")
end

local info_msg= {}

rawset(_G, 'strash_info_msg_add', function (key,message, r, s, print_condition_func)
	if r==nil then r=1 end
	if s==nil then s=0 end
	table.insert(info_msg, {
		id= key,
		text= message,
		repeatation= r,
		start= s,
		func_print_condition= print_condition_func
	})
end)

local iteration= function (player)
	if player.info_msg==nil then
		player.info_msg={}
		for i,obj in pairs(info_msg) do
			table.insert(player.info_msg, obj.start)
		end
	end
	local minim= nil
	local s="{"
	local m_i=0
	for i,iter in pairs(player.info_msg) do
		local obj= info_msg[i]
		s= s..i.." - '"..obj.id.."' "..":("..obj.repeatation..", "..iter.."); "
		if (minim==nil) and (iter==0)
			and ((not obj.func_print_condition) or obj.func_print_condition(player))
		then
			minim= obj
			m_i= i
		elseif iter<0 and obj.repeatation>0 then
			player.info_msg[i]= obj.repeatation
		elseif iter>0 then
			player.info_msg[i]= iter-1
		end
	end
	s= s.."}"
	strash_log(server,"info_msg= "..s)
	if minim then
		player.info_msg[m_i]= $-1
	end
	
	return minim
end

local _msgHandled= false
addHook("ThinkFrame", function()
	if _msgHandled or (leveltime < 2*TICRATE) then return end
	
	_msgHandled= true
	for p in players.iterate do
		local m_obj= iteration(p)
		if m_obj then
			if m_obj.text and #m_obj.text>0
			then
				strash_log(p,"printing message")
				chatprintf(p, m_obj.text, true)
			end
		end
	end
end)

addHook("MapLoad", function(mapnum)
	_msgHandled= false
end)